<!DOCTYPE html>
<html lang="en">
<head>
    <title>Danh sách các bình luận</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script></title>
<body>
    <div class="container">
        <div class="text-center my-4">
            <h3><span style="color:brown">Danh sách </span>bình luận (Comment) của bài viết</h3> 
        </div>
        <div class="row form-group">
            <div class="col-sm-2">
                <label class="form-control border border-0 text-dark">Điền Post Id: </label>
            </div>
            <div class="col-sm-6">
                <input type="text" id="inp-id" class="form-control" placeholder="...điền Post Id, ví dụ: 2, 3...">
            </div>
            <div class="col-sm-4">
                <button class="btn btn-success" id="btn-layComment">Lấy danh sách bình luận của bài biết</button>
            </div>
        </div>
        <div>
            <table class="table table-bordered table-hover table-striped" id="tbl-user-posts">
                <thead>
                    <tr>
                        <th>Id</th>
                        <th>PostId</th>
                        <th>Email</th>
                        <th>Name (Nhan đề)</th>
                        <th>Body (Nội dung)</th>
                        <th>Action</th>
                    </tr>
                </thead>

                <tbody>
                    <tr>
                        <td>1</td>
                        <td>1</td>
                        <td>Eliseo@gardner.biz</td>
                        <td>id labore ex et quam laborum</td>
                        <td>laudantium enim quasi est quidem</td>
                        <td>...</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>1</td>
                        <td>ayne_Kuhic@sydney.com</td>
                        <td>quo vero reiciendis velit similique earum</td>
                        <td>est natus enim nihil est dolore omnis voluptatem numquam</td>
                        <td>...</td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
</body>
<script>
    "use strict";
    //REGION 1
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://jsonplaceholder.typicode.com";
    //REGION 2
    $(document).ready(function(){
        $("#btn-layComment").on("click", onBtnLayCommentClick);
    })
    //REGION 3
    //hàm sử lý sự kiện click nút lấy comment
    function onBtnLayCommentClick(event){
        //b1: khai báo biến lưu dữ liệu
        //và thu thập dữ liệu
        var vPostId = {postId: ""};
        getDataInpPostId(vPostId);
        //b2: kiểm tra dữ liệu
        var vIsCheck = validatePostId(vPostId);
        if(vIsCheck){
            //b3: gọi api (server)
            $.ajax({
                url: gBASE_URL + "/posts/" + vPostId.postId + "/comments/",
                type: "GET",
                success: function(response){
                    //load dữ liệu vào bảng
                    loadDataToTable(response);
                },
                error: function(xhr, status, error){
                    console.log(error);
                }
            })
            //b4 hiển thị thông tin vào table
        }
        
    }
    //hàm xử lý sự kiện nút detail được click
    function onBtnDetailClick(paramEvent){
        var vBtnDetailClick = paramEvent.currentTarget
        const vFORM_TO_OPEN = "Task 520 HienThiChiTietComment.html"
        var vUrlOpenToPage = vFORM_TO_OPEN + "?" + "id=" + $(vBtnDetailClick).data("id");
        window.location.href = vUrlOpenToPage;
    }
    //REGION 4
    //hàm lấy dữ liệu inp use nhập vào
    function getDataInpPostId(paramPostId){
        paramPostId.postId = $("#inp-id").val().trim();
    }
    //hàm kiểm tra dữ liệu
    function validatePostId(paramPostId){
        if(paramPostId.postId == ""){
            alert("Dữ liệu PostId chưa được nhập vào");
            $("#inp-id").focus();
            return false;
        }
        if(isNaN(paramPostId.postId)){
            alert("PostId nhập vào phải là số nguyên");
            return false;
        }
        return true;
    }
    //hàm xóa trắng table
    function resetTableData(){
        var vTable = $("#tbl-user-posts"); //truy cập vào bảng,
        vTable.find("tbody").html("");  //vào phần tboy, xóa trắng
    }
    //hàm load dữ liệu vào table
    function loadDataToTable(paramResponse){
        //xóa trắng phần body của bảng
        resetTableData();
        for(let bI = 0; bI < paramResponse.length; bI++){
            var bNewRow = $("<tr>").appendTo($("#tbl-user-posts tbody"));

            $("<td>")
                .html(paramResponse[bI].id)
                .appendTo(bNewRow);

            $("<td>", {
                html: paramResponse[bI].postId
            }).appendTo(bNewRow);

            $("<td>", {
                html: paramResponse[bI].email
            }).appendTo(bNewRow);

            $("<td>", {
                html: paramResponse[bI].name
            }).appendTo(bNewRow);

            $("<td>", {
                html: paramResponse[bI].body
            }).appendTo(bNewRow);

            //ở action
            var bCellAction = $("<td>").appendTo(bNewRow)
                $("<button>", {
                    html: "chi tết",
                    class: "btn btn-primary"
                }).click(onBtnDetailClick)
                .data("id", paramResponse[bI].id)
                .appendTo(bCellAction);
        }
    }
</script>
</html>